package net.sf.l2j.gameserver.handler.voicedcommandhandlers;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.logging.Logger;
import net.sf.l2j.gameserver.util.FloodProtector;
import net.sf.l2j.L2DatabaseFactory;
import net.sf.l2j.gameserver.handler.IVoicedCommandHandler;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;

public class ipblock
    implements IVoicedCommandHandler
{

    public ipblock()
    {
    }

    public boolean useVoicedCommand(String s, L2PcInstance l2pcinstance, String s1)
    {
        if(s.startsWith("ipblock"))
        {
			if (!FloodProtector.getInstance().tryPerformAction(l2pcinstance.getObjectId(), FloodProtector.PROTECTED_IPBLOCK))
				return false;
            Object obj = null;
            Object obj1 = null;
            try
            {
                Connection connection = L2DatabaseFactory.getInstance().getConnection();
                PreparedStatement preparedstatement = connection.prepareStatement("SELECT * FROM accounts WHERE login=?");
                preparedstatement.setString(1, l2pcinstance.getAccountName());
                ResultSet resultset = preparedstatement.executeQuery();
                resultset.next();
                if(resultset.getBoolean("IPBlock"))
                {
                    PreparedStatement preparedstatement1 = connection.prepareStatement("UPDATE accounts SET ipblock = 0 WHERE login=?");
                    preparedstatement1.setString(1, l2pcinstance.getAccountName());
                    preparedstatement1.execute();
                    l2pcinstance.sendMessage("\u0412\u0430\u0448 \u0430\u043A\u043A\u0430\u0443\u043D\u0442 \u0431\u043E\u043B\u044C\u0448\u0435 \u043D\u0435 \u043F\u0440\u0438\u0432\u044F\u0437\u0430\u043D \u043A ip-\u0430\u0434\u0440\u0435\u0441\u0443");
                    _log.info((new StringBuilder()).append("changing ip block mode for account ").append(l2pcinstance.getAccountName()).append(": Blocking off").toString());
                } else
                {
                    PreparedStatement preparedstatement2 = connection.prepareStatement("UPDATE accounts SET ipblock = 1 WHERE login=?");
                    preparedstatement2.setString(1, l2pcinstance.getAccountName());
                    preparedstatement2.execute();
                    l2pcinstance.sendMessage((new StringBuilder()).append("\u0412\u0430\u0448 \u0430\u043A\u043A\u0430\u0443\u043D\u0442 \u0431\u044B\u043B \u043F\u0440\u0438\u0432\u044F\u0437\u0430\u043D \u043A ip-\u0430\u0434\u0440\u0435\u0441\u0443 ").append(resultset.getString("lastIP")).toString());
                    _log.info((new StringBuilder()).append("changing ip block mode for account ").append(l2pcinstance.getAccountName()).append(": Blocking on").toString());
                }
            }
            catch(SQLException sqlexception)
            {
                _log.warning((new StringBuilder()).append("Could not store IPBlock mode: ").append(sqlexception).toString());
            }
        }
        return true;
    }

    public String[] getVoicedCommandList()
    {
        return VOICED_COMMANDS;
    }

    private static Logger _log = Logger.getLogger(net.sf.l2j.gameserver.handler.voicedcommandhandlers.ipblock.class.getName());
    private static final String VOICED_COMMANDS[] = {
        "ipblock"
    };

}
