package net.sf.l2j.gameserver.skills.effects;

import net.sf.l2j.gameserver.model.L2CharPosition;
import net.sf.l2j.gameserver.model.L2Effect;
import net.sf.l2j.gameserver.model.actor.instance.L2FolkInstance;
import net.sf.l2j.gameserver.model.actor.instance.L2NpcInstance;
import net.sf.l2j.gameserver.model.actor.instance.L2SiegeSummonInstance;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.serverpackets.BeginRotation;
import net.sf.l2j.gameserver.serverpackets.StopRotation;
import net.sf.l2j.gameserver.skills.Env;
import net.sf.l2j.util.Rnd;

final class EffectBluff extends L2Effect
{
    public EffectBluff(Env env, EffectTemplate template)
    {
        super(env, template);
    }

	@Override
	public EffectType getEffectType()
    {
        return EffectType.BLUFF;
    }

    @Override
	public void onStart()
	{
		if (getEffected() instanceof L2FolkInstance)
			return;
		if (getEffected() instanceof L2NpcInstance && ((L2NpcInstance) getEffected()).getNpcId() == 35062 || getSkill().getId() != 358)
			return;
		if (getEffected() instanceof L2SiegeSummonInstance)
			return;
		BeginRotation br = new BeginRotation(getEffected().getObjectId(), getEffected().getHeading(), 1);
		getEffected().broadcastPacket(br);
		StopRotation sr = new StopRotation(getEffected().getObjectId(), getEffector().getHeading());
		getEffected().broadcastPacket(sr);
		getEffected().setHeading(getEffector().getHeading());
		getEffected().setTarget(null);
		getEffected().startStunning();
		onActionTime();
	}
	
	@Override
	public void onExit()
	{
		getEffected().stopStunning(this);
	}
	
	@Override
	public boolean onActionTime()
	{
		return false;
	}
}
